Subject: Re: bug#2151: 23.0.90; Building the 23.0.90 pretest recompiles Lisp files

From: Eli Zaretskii <[email-masked]>
Date: Sat, 21 Feb 2009 18:10:47 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked]
> Date: Wed, 04 Feb 2009 14:51:49 -0500
> 
> >> > We could add some file to the tarball, generated at make-dist time, to
> >> > signal that bootstrap-emacs is not needed.  That file could actually
> >> > be named `bootstrap-emacs', which should resolve the problem nicely
> >> > (assuming we manage to have it older than the oldest .elc file).
> >> Maybe we can get that to work, but it sounds terribly hackish.
> > Why hackish? many distributions have or create such time-stamp files,
> > for Make's sake.
> 
> I guess it depends on the details.

After thinking some more about this, I don't see any easy and safe
solution besides adding a "bootstrap-emacs" file to the tarball.
Maybe in future releases we will be able to find a better way, but for
now this is the only one that's safe.

I will do that if you agree.

In any case, it sounds wrong to me to have the distribution biased in
favor of people who build Emacs out of CVS.  Those who do that
generally know more about the build procedure than people who build
the release tarball.  We should favor the latter, not the former.

> >> Also, I'd like to make sure that if some wants to change some .el files
> >> and then recompile, it still works correctly.
> > It will, I think, because we can copy emacs to bootstrap-emacs at the
> > end of the build.
> 
> What if they edit .el files before building a first `emacs'?

We could arrange for byte-recompile-directory at the end of the build,
if that is a real-life use-case.  Note that in previous releases, the
user needed to manually compile the modified .el files and re-dump
Emacs in this case, so we are not introducing any new problems, even
if we do nothing about it.